#define _WIN32_WINNT 0x0400

#define HTTP_BUFFER_LENGTH (2*1024)

#define FILE_EXT_UNKNOWN 0
#define FILE_EXT_SOURCE  1
#define FILE_EXT_OBJECT  2

#define MY_MAX_PATH (MAX_PATH*4)

#define RangeResult(x , low, high) (__max(low, __min(x, high)))

typedef bool (* HandleSearchCallBack)(LPTSTR fullName, LPTSTR fileName, LPVOID userData);



bool isFileExist(LPCTSTR fileName, FILETIME* fileTime);

bool getFullName(LPCTSTR shortName, LPTSTR buffer, DWORD bufferSize);

int downloadFile(LPCTSTR url, LPCTSTR fileName, bool preserveServerTime =false);

int checkFileExt(LPCWSTR fileName);

int checkFileExt(LPCSTR fileName);

void ansi2unicode(LPCSTR src, LPWSTR dst);

bool getServerUrl(LPWSTR serverUrl);

void encryption(LPBYTE buffer, DWORD bufferSize);

void decryption(LPBYTE buffer, DWORD bufferSize);

void net2path(LPCTSTR src, LPTSTR dst);
void net2path(LPTSTR path);

void path2net(LPCTSTR src, LPTSTR dst);

void path2net(LPTSTR path);


bool getFileExtName(LPTSTR dstName, LPCTSTR srcName, LPCTSTR extName);

int runShellA(LPSTR command, int argc, LPSTR* argv);

bool getDependFileName(LPWSTR wzProjectName, LPCTSTR srcFileName, LPTSTR depFileName);

char* packArgument(int argc, LPSTR* argv, char ch = ' ');

LPTSTR packArgumentW(int argc, LPTSTR* argv);

bool downloadFileHelper(LPCSTR projectName, LPCSTR shortFileName, LPWSTR command, bool preserveServerTime = false);

void trimTail(LPTSTR buffer);
bool getFileLastWriteTime(LPCTSTR fileName, FILETIME* pftLastWrite);
bool setFileLastWriteTime(LPCTSTR srcFileName, FILETIME* pftLastWrite);

bool printFileTime(FILETIME* lpFileTime, LPSTR buffer);

bool createTempFileNameA(LPSTR buffer, DWORD bufferLength);

bool genericFind(LPCWSTR dir, HandleSearchCallBack handleSearchCallBack, LPVOID userData, bool bFindFile=true);

bool getMyFilePath(LPTSTR pathBuffer);


static bool AllowPrint = true;



//#define  myPrintf printf

//#define mywPrintf wprintf

#define  myPrintf

#define mywPrintf


//#define  myPrintf if (AllowPrint) printf
//#define mywPrintf if (AllowPrint) wprintf



