#include "stdafx.h"

typedef unsigned int uint32;

char superBuffer[MY_MAX_PATH*4];

bool convertObjFileExt(LPTSTR fileName)
{
	bool result = false;
	LPTSTR ptr = _tcsrchr(fileName, _T('.'));
	if (ptr != NULL)
	{
		_stprintf(ptr, _T(".obj"));
		result = true;
	}
	return result; 
}

bool downloadSourceFile(LPTSTR projectName, LPCTSTR fileName, LPCTSTR shortName, FILETIME* pLastWriteTime, bool isSimulator)
{
	WCHAR urlBuffer[HTTP_BUFFER_LENGTH];	
	bool result = false;
	int length;

	// we no longer need file time for downloading.
	
	if (getServerUrl(urlBuffer))
	{
		length = _tcslen(urlBuffer);
		if (isSimulator)
		{
			//_stprintf(urlBuffer + length, _T("source@simulator?%s,%s,%u,%u"), projectName, shortName, pLastWriteTime->dwLowDateTime, pLastWriteTime->dwHighDateTime);
			_stprintf(urlBuffer + length, _T("source@simulator?%s,%s,0,0"), projectName, shortName);
		}
		else
		{
			//_stprintf(urlBuffer + length, _T("source@simulator?%s,%s,%u,%u"), projectName, shortName, pLastWriteTime->dwLowDateTime, pLastWriteTime->dwHighDateTime);
			_stprintf(urlBuffer + length, _T("source@arm?%s,%s,0,0"), projectName, shortName);
		}
	
		mywPrintf(_T("about to download source file %s from %s\n"), shortName, urlBuffer);
		if (downloadFile(urlBuffer, fileName) > 0)
		{
			result = true;
		}	
	}
	return result;
}


bool checkLocalFile(LPCTSTR targetPath, FILETIME* pFileTime)
{
	int fileType;
	TCHAR nameBuffer[MY_MAX_PATH];
	bool result = false;
	
	fileType = checkFileExt(targetPath);

	getFullName(targetPath, nameBuffer, MY_MAX_PATH);

	switch (fileType)
	{
	case FILE_EXT_SOURCE:		
		if (isFileExist(nameBuffer, pFileTime))
		{
			result = true;
		}
		else
		{			
			if (convertObjFileExt(nameBuffer))
			{
				isFileExist(nameBuffer, pFileTime);				
			}
		}
		break;
	}
	return result;
}

int calcArgumentLength(int argc, char** argv)
{
	int length = 0;
	for (int i = 0 ;  i < argc; i ++)
	{
		length += strlen(argv[i]) + 1;
	}	
	return length;
}

int calcArgumentLength(char** argv)
{
	int argc = 0;
	while (argv[argc] != '\0')
	{
		argc ++;
	}
	return calcArgumentLength(argc, argv);
}

void showEvironment(char*envp)
{
	char* ptr = envp;
	myPrintf("\n******************************************\n");
	while (*ptr != '\0')
	{
		myPrintf("%s\n", ptr);
		ptr += strlen(ptr) +1;
	}
	myPrintf("\n******************************************\n");
}

LPSTR getLastSlash(LPCSTR fullPath)
{
	LPSTR ptr = NULL;
	if ((ptr = strrchr(fullPath, '\\'))!= NULL)
	{	
		return ptr;
	}
	if ((ptr = strrchr(fullPath, '/'))!= NULL)
	{		
		return ptr;
	}
	return ptr;
}

//using ascii code only
//LPCSTR ArmCCName = "armtcc.exe";
LPCSTR MetaPrefix = "Ads";
LPCSTR IncludeStr = "C:\\Program Files\\Microsoft SDK\\Include;C:\\Program Files\\Microsoft Visual Studio\\VC98\\INCLUDE;C:\\Program Files\\Microsoft Visual Studio\\VC98\\MFC\\INCLUDE;C:\\Program Files\\Microsoft Visual Studio\\VC98\\ATL\\INCLUDE";
LPCSTR LibStr = "C:\\Program Files\\Microsoft SDK\\Lib;C:\\Program Files\\Microsoft Visual Studio\\VC98\\LIB;C:\\Program Files\\Microsoft Visual Studio\\VC98\\MFC\\LIB";


DWORD runCompiler(int argc, char **argv)
{	
	DWORD result = 1;//by default it should be wrong 
	LPSTR ptr, oldExePtr, oldPtr, myEnvp;
	int length, envCount = 0, oldExeNameOffset;	
	LPSTR myArgv;
	LPSTR myExeName;
	PROCESS_INFORMATION pi;
	STARTUPINFOA si;
	bool isShortName =false;
	//char envBuffer[MY_MAX_PATH* 2];

	myPrintf("\n************************run compiler******************************\n"); 
	//here is the potential problem
	if ((oldExePtr = getLastSlash(argv[0])) == NULL)	
	{
		//myPrintf("short exe name\n");		
		oldExeNameOffset = 0;
		oldExePtr = argv[0];
		isShortName = true;
	}
	else
	{
		oldExePtr ++;
		oldExeNameOffset = oldExePtr - argv[0];
	}	
	// let's add quote for long file name
	if (!isShortName)
	{
		length = sizeof(char)*(strlen(argv[0]) + strlen(MetaPrefix) + 3); //change tcc to armcc 
	}
	else
	{
		length = sizeof(char)*(strlen(argv[0]) + strlen(MetaPrefix) + 1); //change tcc to armcc 
	}

	if ((myExeName = (LPSTR)malloc(length)) != NULL)
	{
		strcpy(myExeName, argv[0]);
		ptr = myExeName + oldExeNameOffset;		
		sprintf(ptr, "%s%s", MetaPrefix, oldExePtr);	
		oldPtr = argv[0];
		argv[0] = myExeName;
		if ((myArgv = packArgument(argc, argv))!= NULL)
		{		
			ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
			ZeroMemory(&si, sizeof(STARTUPINFO));
			si.cb = sizeof(STARTUPINFO);
			//showEvironment(myEnvp);
			
			if (CreateProcessA(NULL, myArgv, NULL, NULL, FALSE, 0,  NULL, NULL, &si, &pi))
			{
				WaitForSingleObject(pi.hProcess, INFINITE);
				GetExitCodeProcess(pi.hProcess, &result);
				CloseHandle(pi.hProcess);
				CloseHandle(pi.hThread);
				myPrintf("\n'%s' succeed replacing '%s' of param:[%s] \n", myExeName, oldPtr, myArgv);				
			}
			else
			{
				myPrintf("\n****************\ncreate process failed with error %d exe[%s] param[%s]\n**************\n\n",
					GetLastError(), myExeName, myArgv);
			}		
			free(myArgv);
		}	
		argv[0] = oldPtr;
		free(myExeName);
	}
	return result;
}

bool deleteSrcFile(LPCTSTR srcFileName)
{
	HANDLE handle;
	FILETIME ftLastWrite;
	if (getFileLastWriteTime(srcFileName, &ftLastWrite))
	{
		if ((handle = CreateFile(srcFileName, GENERIC_WRITE, FILE_SHARE_DELETE, NULL, TRUNCATE_EXISTING, FILE_ATTRIBUTE_ENCRYPTED, NULL)) != INVALID_HANDLE_VALUE)
		{
			SetFileTime(handle, NULL, NULL, &ftLastWrite);
			CloseHandle(handle);
			return true;
		}
	}
	return false;
}

bool getProjectName(int argc, LPSTR* argv, LPTSTR buffer)
{
	LPCSTR ProjectPrefix = "-DPRJ_";
	LPSTR ptr;
	int i;
	for (i=0; i< argc; i ++)
	{
		if (strnicmp(argv[i], ProjectPrefix, 6) == 0)
		{
			ptr = argv[i] + 6;
			_stprintf(buffer, _T("%hs"), ptr);
			return true;
		}
	}
	return false;
}

bool getObjFileTime(int argc, LPSTR* argv, FILETIME* pFileTime)
{
	bool result = false;
	WCHAR objFileName[MY_MAX_PATH];
	WCHAR fullFileName[MY_MAX_PATH];
	for (int i = 0; i< argc; i ++)
	{
		if (stricmp(argv[i], "-o") == 0)
		{
			break;
		}
	}
	i++; //next
	if (i >= argc)
	{
		return false;
	}
	ansi2unicode(argv[i], objFileName);
	net2path(objFileName);
	if (getFullName(objFileName, fullFileName, MY_MAX_PATH))
	{
		isFileExist(fullFileName, pFileTime);
		result = true;
	}
	return result;
}

bool isMetaDefined(int argc, LPSTR* argv)
{
	LPCSTR MetaPrefix = "-DMETA_EDIT";
	
	for (int i=0; i< argc; i ++)
	{
		if (strcmp(argv[i], MetaPrefix) == 0)
		{
			return true;
		}
	}	
	return false;
}

bool checkSourceExist(LPTSTR srcShortName, LPTSTR srcFullName, FILETIME* pFileTime)
{
	bool result = false;

	ZeroMemory(pFileTime, sizeof(FILETIME)); 

	if (isFileExist(srcFullName, pFileTime))
	{
		result = true;
	}	
	return result;
}

// to do we need short name
bool checkObjectFileTime(LPTSTR srcShortName, LPTSTR objectPath, FILETIME* pFileTime)
{
	TCHAR objectName[MY_MAX_PATH];
	int length;
	LPTSTR srcPtr;
	LPTSTR ptr;
	bool result = false;
	if (GetCurrentDirectory(MY_MAX_PATH, objectName))
	{
		net2path(objectPath);
		
		if ((srcPtr = _tcsrchr(srcShortName, _T('\\')))== NULL)
		{
			srcPtr = srcShortName;
		}
		
		length = _tcslen(objectPath);
		if (objectPath[length-1] == _T('\\'))
		{
			objectPath[length-1] = _T('\0');			
		}

		length = _tcslen(objectName);
		_stprintf(objectName + length, _T("\\%s%s"), objectPath, srcPtr);

		if ((ptr = _tcsrchr(objectName, _T('.')))!= NULL)
		{
			_stprintf(ptr, _T(".obj"));
			if (isFileExist(objectName, pFileTime))
			{
				result = true;
			}
		}
	}
	return result;
}

/*
bool isMetaDefined(LPSTR buffer, LPSTR srcName, LPSTR projectName, LPSTR objectName)
{
	LPSTR ptr;
	bool isFirst = false, isSecond =false, isMeta =false;
	bool isObject = false;
	int length;

	ptr = strtok(buffer, " ");

	while (ptr)
	{
		while (*ptr== ' ' || *ptr == '\n')
		{
			ptr ++;		
		}
		if (*ptr == '\0')
		{
			break;
		}
		strcpy(srcName, ptr);

		if (strcmp("/D", ptr) == 0)
		{					
			isFirst = true;
			isSecond =false;
		}
		else
		{
			if (isFirst)
			{
				isSecond =true;
			}
			else
			{
				isSecond =false;
			}
			isFirst =false;
		}

		if (strncmp("/Fo", ptr, 3) == 0)
		{
			if (ptr[3] == '"')
			{
				strcpy(objectName, ptr + 4);
				length = strlen(objectName);
				objectName[length -1] = '\0';
			}
		}
		
		if (isSecond)
		{
			if (stricmp(ptr, "\"META_EDIT\"") == 0)
			{
				isMeta = true;				
			}
			if (strncmp(ptr, "\"PRJ_", 5) == 0)
			{
				strcpy(projectName, ptr + 5);	
				length = strlen(projectName);
				projectName[length-1] = '\0';
			}
		}
		ptr = strtok(NULL, " ");
	}
	return isMeta;
}
*/

bool getRelativePath(LPCTSTR fullName, LPTSTR shortName)
{
	bool result = false;
	TCHAR currentPath[MY_MAX_PATH];
	LPTSTR ptr, pStart;
	GetCurrentDirectory(MY_MAX_PATH, currentPath);
	//assume simulator is ProjectDirectory\win32\build
	for (int i =0; i< 2; i++)
	{
		if ((ptr = _tcsrchr(currentPath, _T('\\'))) != NULL)
		{
			*ptr = _T('\0');
		}
	}
	if ((ptr = _tcsrchr(currentPath, _T('\\'))) != NULL)
	{
		ptr ++;
	}

	if ((pStart = _tcsstr(fullName, ptr))!= NULL)
	{
		if ((pStart=_tcschr(pStart, _T('\\')))!= NULL)
		{
			_stprintf(shortName, _T("..\\..%s"), pStart);
			result = true;
		}
	}
	return result;
}



bool getSourceFileAllNamePath(LPCSTR rawName, LPTSTR shortName, LPTSTR fullName, bool isSimulator)
{
	bool result = false;
	int length;
	//in case of arm, the raw name maybe already relative path
	if (!isSimulator)
	{
		ansi2unicode(rawName, shortName);
		net2path(shortName);
		getFullName(shortName, fullName, MY_MAX_PATH);
		result = true;
	}
	else
	{
		//in case of simulator, the raw name maybe absolute path with quotes added possibly
		if (rawName[0] == '"')
		{
			_stprintf(fullName, _T("%hs"), rawName+1);
			length = _tcslen(fullName);
			fullName[length -1] = _T('\0');
		}
		//find relative path from absolute path
		if (getRelativePath(fullName, shortName))
		{	
			result = true;		
		}
	}
	return result;
}
		
bool hasSourceFile(int argc, LPSTR* argv)
{
	if (checkFileExt(argv[argc-1]) == FILE_EXT_SOURCE)
	{
		return true;
	}
	return false;
}

int runArm(int argc, LPSTR* argv)
{
	LPSTR ptr;
	ptr = argv[argc-1];	
	TCHAR shortName[MY_MAX_PATH];
	TCHAR fullName[MY_MAX_PATH];
	FILETIME fileTime;
	bool bToDelete = false;
	bool bNeedCompile = true;
	int result = 0;
	TCHAR projectName[MAX_PATH];

	if (hasSourceFile(argc, argv))
	{
		AllowPrint = true;
		myPrintf("run arm...\n");
		if (isMetaDefined(argc, argv))
		{			
			if (getProjectName(argc, argv, projectName))
			{
				bNeedCompile = false;
				if (getSourceFileAllNamePath(argv[argc-1], shortName, fullName, false))
				{
					if (!isFileExist(fullName, &fileTime))
					{
						// we no longer need object file time to check!!!
						/*
						if (!getObjFileTime(argc, argv, &fileTime))
						{
							ZeroMemory(&fileTime, sizeof(FILETIME));
						}
						*/
						if (!downloadSourceFile(projectName, fullName, shortName, &fileTime, false))
						{
							mywPrintf(_T("src file %s cannot be downloaded, maybe the object file is already new enough\n"), shortName);								
						}
						else
						{
							// we get source file from server
							bNeedCompile = true;
							bToDelete = true;
						}
					}
					else
					{
						mywPrintf(_T("src file %s exists...\n"), shortName);
						bNeedCompile = true;
					}
				}
			}
			else
			{
				myPrintf("cannot get project name!\n\n");
			}
		}
	}
	else
	{
		AllowPrint = false;
	}

	if (bNeedCompile)
	{
		result = runCompiler(argc, argv);
	}
	if (bToDelete)
	{
		deleteSrcFile(fullName);
	}
	return result;
}

bool isMetaDefined(FILE* stream, LPTSTR projectName, LPTSTR objectPath)
{
	char buffer[MY_MAX_PATH];
	bool bDefined = false, bMeta = false, bProjectDefined = false, bObjectPathDefined= false;
	int length;
	while (fscanf(stream, "%s", buffer)!= EOF)
	{
		if (strcmp(buffer, "/D")==0)
		{
			bDefined = true;
		}
		else
		{
			if (bDefined)
			{
				if (strncmp("\"PRJ_", buffer, 5) == 0)
				{
					_stprintf(projectName, _T("%hs"), buffer + 5);
					length = _tcslen(projectName);
					projectName[length-1] = _T('\0');
					bProjectDefined = true;
				}
				if (strcmp("\"META_EDIT\"", buffer)==0)
				{
					bMeta = true;
				}
			}
			bDefined = false;
		}
		if (strncmp("/Fd\"", buffer, 4) == 0)
		{
			_stprintf(objectPath, _T("%hs"), buffer + 4);
			length = _tcslen(objectPath);			
			objectPath[length - 1] = _T('\0');
			bObjectPathDefined = true;
		}
		if (strcmp("/c", buffer) == 0)
		{
			// this means the end of parsing...
			break;
		}
	}
	return bMeta&&bProjectDefined&&bObjectPathDefined;
}

void prepareDownloadSourceFile(LPSTR superBuffer, FILE* stream, long& paramOffset)
{
	char ch;
	paramOffset = ftell(stream);
	do
	{
		ch= fgetc(stream);
		if (ch == ' ' || ch == '\n' || ch== '\r')
		{
			paramOffset++;
		}
		else
		{
			break;
		}
	}
	while(!feof(stream));

	paramOffset -= 1;		

	fseek(stream, 0, SEEK_SET);

	fread(superBuffer, paramOffset, 1, stream);
	superBuffer[paramOffset] ='\0';
}

// by default we need to compile, unless it is not downloadable!!!
bool getSingleSourceFile(LPSTR srcName, LPTSTR projectName, LPTSTR objectPath, LPTSTR fullName, bool& bToCompile, bool& bToDelete)
{
	TCHAR shortName[MY_MAX_PATH];
	FILETIME fileTime;
	bool result = true;
	if (getSourceFileAllNamePath(srcName, shortName, fullName, true))
	{
		if (!isFileExist(fullName, &fileTime))
		{
			if (!checkObjectFileTime(shortName, objectPath, &fileTime))
			{
				ZeroMemory(&fileTime, sizeof(FILETIME));
			}
			mywPrintf(L"getsinglesourcefile:[srcName]%hs, [projectName]%ls,[objectPath]%ls, [fullname]%ls\n", srcName, projectName, objectPath, fullName);
			if (!downloadSourceFile(projectName, fullName, shortName, &fileTime, true))
			{
				myPrintf("get src %s file failed from server maybe the object is already new enough\n", srcName);
				result = false;
				bToCompile = false;
				bToDelete  = false;
			}
			else
			{
				bToCompile = true;
				bToDelete =true;
			}
		}
		else
		{
			bToCompile =true;
			bToDelete = false;
		}
	}
	return result;
}

int runCompilerForEachFile(LPCSTR superBuffer, int bufferLength, LPCSTR srcName, LPSTR compilerName)
{
	FILE* stream;
	char fileName[MY_MAX_PATH];
	LPSTR fileNamePtr;
	char* myArg[2];
	fileName[0]='@';
	int result = 0;
	fileNamePtr = fileName +1;
	if (createTempFileNameA(fileNamePtr, MY_MAX_PATH))
	{		
		myPrintf("create temp file succeed [%s]\n", fileNamePtr);
		if ((stream = fopen(fileNamePtr, "w"))!= NULL)
		{
			myPrintf("[tempname]%s\n", fileName);
			fwrite(superBuffer, bufferLength, 1, stream);
			fwrite(srcName, strlen(srcName), 1, stream);
			fclose(stream);
			myArg[0]= compilerName;
			myArg[1]= fileName;
			result = runCompiler(2, myArg);
			DeleteFileA(fileNamePtr);				
		}
	}
	return result;
}

int runSimulator(int argc, LPSTR* argv)
{	
	int result = 0;
	long paramOffset, offset;
	char srcName[MY_MAX_PATH];
	TCHAR srcFullName[MY_MAX_PATH];
	TCHAR projectName[MAX_PATH];
	TCHAR objectPath[MAX_PATH];
	int bufferLength;
	bool bToCompile =false, bToDelete =false;

		
	FILE* stream= NULL;
	if ((stream = fopen(argv[1]+1, "r"))!= NULL)
	{	
		if (isMetaDefined(stream, projectName, objectPath))
		{
			prepareDownloadSourceFile(superBuffer, stream, paramOffset);

			bufferLength = strlen(superBuffer);
			myPrintf("[superbuffer]%s\n", superBuffer);
			while (fscanf(stream, "%s", srcName) != EOF)
			{				
				if (getSingleSourceFile(srcName, projectName, objectPath, srcFullName, bToCompile, bToDelete))
				{	
					mywPrintf(L"[source]%hs[project]%ls[objectPath]%ls[srcFullName]%ls\n", srcName, projectName, objectPath, srcFullName);					
				}
				if (bToCompile)
				{
					result = runCompilerForEachFile(superBuffer, bufferLength, srcName, argv[0]);				
				}
				if (bToDelete)
				{
					deleteSrcFile(srcFullName);					
				}
				if (result != 0)
				{
					break;
				}
			}
			fclose(stream);
		}	
		else
		{
			fclose(stream);
			result = runCompiler(argc, argv);
		}		
	}
	return result;
}


int main(int argc, LPSTR* argv)
{	
	if (argc ==2 && argv[1][0] == '@')
	{
		myPrintf("run simulator...\n");
		return runSimulator(argc, argv);
	}
	else
	{		
		return runArm(argc, argv);
	}	
}
